function love.gamepadpressed(joystick, button)
        local inputtype, inputindex, hatdirection = joystick:getGamepadMapping(button)
        inputtype = inputtype or "nil"
        inputindex = inputindex or "nil"
        hatdirection = hatdirection or "nil"

        print("pressed "..button.." with type "..inputtype..", index "..inputindex..", hatdir "..hatdirection.." on gamepad "..joystick:getGUID())
end

function love.joystickpressed(joystick, button)
        print("pressed "..button.." on joystick "..joystick:getGUID())
end

function love.load(arg)
    -- find the first connected joystick
    local joystick_list = love.joystick.getJoysticks()
    local joystick = joystick_list[1]

    if joystick:isGamepad() then
        print("new gamepad '"..joystick:getName().."' with GUID "..joystick:getGUID())
    else
        print("new joystick '"..joystick:getName().."' with GUID "..joystick:getGUID())
    end
    
    -- try to remap the button that *should* be leftshoulder; if console argument is given, use that
    local leftshoulder_button_number = tonumber(arg[2]) or 7
    local success = love.joystick.setGamepadMapping("050000005e040000fd02000003090000", "leftshoulder", "button", leftshoulder_button_number, nil)
    print("success mapping button "..leftshoulder_button_number.." to leftshoulder? "..tostring(success))

    --- load gamepad mapping (commented out to test one of the two mapping functions)
    --love.joystick.loadGamepadMappings("custom_gamecontroller_db.txt")
end
